<?php
/* $Id: function.inc.php,v 1.29 2007/11/28 18:21:02 chelout Exp $ */

@include_once("../vars.inc.php");

require_once($ADMIN_FOLDER.'CheckUserFunctions.inc.php');
require_once($ADMIN_FOLDER.'catalog.inc.php');
require_once($ADMIN_FOLDER.'class.inc.php');
require_once($ADMIN_FOLDER.'message.inc.php');
require_once($ADMIN_FOLDER.'template.inc.php');
require_once($ADMIN_FOLDER.'field.inc.php');
require_once($ADMIN_FOLDER.'system_table.inc.php');
require_once($ADMIN_FOLDER.'module.inc.php');
require_once($ADMIN_FOLDER.'admin.inc.php');


// Admin Interface Initialization
$admin_mode = true;
if ($AUTHORIZATION_TYPE=='session') { session_start(); }

LoadSettings();
Authorize(1);

#   
if ($_POST["NEW_AUTH_LANG"])
{
    $SETNEWLANG=$_POST["NEW_AUTH_LANG"];
}
elseif($_GET["NEW_AUTH_LANG"])
{
    $SETNEWLANG=$_GET["NEW_AUTH_LANG"];
}

#   
if ($AUTH_USER_ID && $NEW_AUTH_LANG)
{
    $AUTH_LANG=$SETNEWLANG;
    //         
    //  Authorize --   if ($Language)

//    setcookie('AUTH_LANG', $AUTH_LANG, mktime(0,0,0,1,1,2037), "/");
    $db->query("UPDATE User SET Language='".$AUTH_LANG."' WHERE User_ID='".$AUTH_USER_ID."'");
}

if (preg_match("/^\w+$/", $AUTH_LANG))
{
    require_once($ADMIN_FOLDER."lang/".$AUTH_LANG.".php");
}
elseif(preg_match("/^\w+$/", $PHP_AUTH_LANG))
{
    require_once($ADMIN_FOLDER."lang/".$PHP_AUTH_LANG.".php");
}
elseif(preg_match("/^\w+$/", $_SESSION['User']['PHP_AUTH_LANG']))
{
    require_once($ADMIN_FOLDER."lang/".$_SESSION['User']['PHP_AUTH_LANG'].".php");
}
else
{
    if (!$PHP_AUTH_LANG)
    {
        $PHP_AUTH_LANG=NetCat_language_detect();
    }
    if ($PHP_AUTH_LANG)
    {
        require_once($ADMIN_FOLDER."lang/".$PHP_AUTH_LANG.".php");
    }
    else
    {
        require_once($ADMIN_FOLDER."lang/".$ADMIN_LANGUAGE.".php");
    }
}

//    ,    
// ""  
header("Content-Type: text/html; charset=".MAIN_ENCODING);

//        

if (!$perm->isSupervisor() && !$perm->isManager() &&
    !$perm->isInstanceModeratorAdmin('catalogue') &&
    !$perm->isInstanceModeratorAdmin('subdivision') &&
    !$perm->isInstanceModeratorAdmin('subclass'))
{
    if (NC_ADMIN_ASK_PASSWORD!==false)
    {
       BeginHtml (BEGINHTML_TITLE, BEGINHTML_TITLE, "http://".$DOC_DOMAIN."/admin/");
       nc_print_status($NO_RIGHTS_MESSAGE, 'error');
       EndHtml ();
    }
		else {
		   print "\n/* You have no rights to access this area */\n";
		}
    exit;
}

// --- Common functions


function LoadSettings ()
{
    global $db;
    global $IsInsideAdmin, $system_env;
    global $PROJECT_NAME, $VERSION_ID, $PLUGS_INSTALL_TYPE, $ANY_SYSTEM_MESSAGE, $SYSTEM_ID,$ADMIN_FOLDER;
    global $SPAM_FIELD, $SPAM_MAIL, $SPAM_FROM, $SPAM_FROM_NAME, $NO_RIGHTS_MESSAGE, $PATCH_CHECK_DATE;
    global $LAST_PATCH, $LAST_LOCAL_PATCH, $SYSTEM_NAME, $SYSTEM_COLOR;
    global $HTTP_HOST, $REMOTE_ADDR, $HTTP_USER_AGENT;
    global $EDITOR_TYPE, $EMBED_EDITOR;


    $Array = $db->get_row("SELECT settings.*, field.Field_Name AS UserEmail FROM Settings AS settings LEFT JOIN Field AS field ON settings.UserEmailField = field.Field_ID ORDER BY Settings_ID LIMIT 1", ARRAY_A);

    // probably system was not installed:
    if (!sizeof($Array))
    {
       if (file_exists("$GLOBALS[DOCUMENT_ROOT]/install/index.php"))
            { header("Location: /install/"); }
       else { print "<p><b>".NETCAT_ERROR_DB_CONNECT."</b></p>"; }

       die();
    }

    $PROJECT_NAME = $Array['ProjectName'];
    $PRODUCT_CODE = $Array['ProductNumber'];
    $SYSTEM_ID = $Array['SystemID'];
    $VERSION_ID = $Array['VersionNumber'];
    $SPAM_FIELD = $Array['UserEmailField'];
    $SPAM_MAIL = $Array['UserEmail'];
    $SPAM_FROM = $Array['SpamFromEmail'];
    $SPAM_FROM_NAME = $Array['SpamFromName'];
    $EDITOR_TYPE = $Array['EditorType'];
    $EMBED_EDITOR = $Array['EmbedEditor'];

    switch ($SYSTEM_ID)
    {
        case "1":
            $SYSTEM_NAME = 'Small Business';
            $SYSTEM_COLOR = '#ff9900';
            break;
        case "2":
            $SYSTEM_NAME = 'Standard';
            $SYSTEM_COLOR = '#2690cf';
            break;
        case "3":
            $SYSTEM_NAME = 'Extra';
            $SYSTEM_COLOR = '#cc3300';
            break;
        case "4":
            $SYSTEM_NAME = 'Community';
            $SYSTEM_COLOR = '#65C11A';
            break;
        case "5":
            $SYSTEM_NAME = 'Lite';
            $SYSTEM_COLOR = 'black';
            break;
        case "6":
            $SYSTEM_NAME = 'E-Commerce';
            $SYSTEM_COLOR = '#F07D22';
            break;
        case "7":
            $SYSTEM_NAME = 'SEO';
            $SYSTEM_COLOR = '#FDCC6D';
            break;
        case "8":
            $SYSTEM_NAME = 'Corporate';
            $SYSTEM_COLOR = '#525F67';
            break;
    }

    $PLUGS_INSTALL_TYPE = "int";

    $LAST_LOCAL_PATCH = $db->get_var("SELECT Patch_Name FROM Patch ORDER BY Patch_Name DESC LIMIT 1");
    $LAST_LOCAL_PATCH += 0;

    list($LAST_PATCH,$PATCH_CHECK_DATE,$PATCH_CHECK_NEEDED) = $db->get_row("SELECT LastPatch,DATE_FORMAT(PatchCheck,'%d.%m.%Y'),DATE_ADD(PatchCheck,INTERVAL 7 DAY)<=CURDATE() FROM Settings",ARRAY_N);

    if (($PATCH_CHECK_NEEDED!="0" && $LAST_PATCH<=$LAST_LOCAL_PATCH) || $IsInsideAdmin)
    {
        // get module list in order to get correct patch
        require($ADMIN_FOLDER."modules/module_list.inc.php");

        $installed_modules = $db->get_results("SELECT Keyword
                                                 FROM Module
                                                WHERE Keyword IN ('".join("','", array_keys($real_modules))."')
                                               ", ARRAY_N);
        // flatten array:
        if ($installed_modules)
        {
           foreach ($installed_modules as $k=>$v) { $installed_modules[$k] = $v[0]; }
           $installed_modules = urlencode(join(',', $installed_modules));
        }

        $LAST_PATCH = "";

        $patch_url = "/netcat/modules/default/patch.php?system=$Array[SystemID]&version=$Array[VersionNumber]&lastpatch=$LAST_LOCAL_PATCH&host=$HTTP_HOST&product=$PRODUCT_CODE&useremail=".urlencode($SPAM_FROM)."&adminfolder=".urlencode($ADMIN_FOLDER)."&userip=$REMOTE_ADDR&useragent=".urlencode($HTTP_USER_AGENT)."&modules=$installed_modules";

        if (strpos(ini_get("disable_functions"), "fsockopen")===FALSE) {
           $fs = @fsockopen("www.netcat.ru", 80, $errno, $errstr, 7);
           if ($fs) {
              $req  = "GET $patch_url HTTP/1.0\r\n";
              $req .= "Host: www.netcat.ru\r\n";
              $req .= "Connection: Close\r\n\r\n";

              fwrite($fs, $req);
              while (!feof($fs)) {
                $response .= fgets($fs, 1024);
              }
              fclose($fs);

              $LAST_PATCH = preg_replace("/^.+?\r\n\r\n/s", "", $response);
           }
        }
        else {
          $LAST_PATCH = @join('', @file("http://www.netcat.ru$patch_url"));
        }

        $db->query("UPDATE Settings SET PatchCheck=CURDATE(),LastPatch=".($LAST_PATCH+0));
    }

    $ANY_SYSTEM_MESSAGE = $db->get_var("SELECT count(*) FROM SystemMessage WHERE Checked=0");

    $system_env['Powered'] = "PHP/".phpversion();
}

function BeginHtml ($title='', $location='', $HelpURL='')
{
    # $title - ,     <title>
    global $NO_RIGHTS_MESSAGE;
    $NO_RIGHTS_MESSAGE = NETCAT_MODERATION_ERROR_NORIGHTS;
    ?>

<html lang='<?=MAIN_LANG?>' dir='<?=MAIN_DIR?>'>
<head>
  <title><?=($title?$title:"NetCat")?></title>
  <link type='text/css' rel='Stylesheet' href='/netcat/admin/skins/default/css/admin.css'>
  <script type='text/javascript' src='/netcat/admin/js/lib.js'></script>
  <script type='text/javascript' src='/netcat/admin/js/forms.js'></script>
  <script type='text/javascript' src='/netcat/admin/js/sitemap.js'></script>
  <?php

    if ($GLOBALS["BBCODE"]) {
       print "<script type='text/javascript' src='/netcat/admin/js/bbcode.js'></script>\n";
    }

    if ($GLOBALS["AJAX_SAVER"]) {
       print "<script>
       var formAsyncSaveEnabled = true, ".
          "NETCAT_HTTP_REQUEST_SAVING = \"".str_replace('"', "&quot;", NETCAT_HTTP_REQUEST_SAVING)."\", ".
          "NETCAT_HTTP_REQUEST_SAVED  = \"".str_replace('"', "&quot;", NETCAT_HTTP_REQUEST_SAVED )."\", ".
          "NETCAT_HTTP_REQUEST_ERROR  = \"".str_replace('"', "&quot;", NETCAT_HTTP_REQUEST_ERROR )."\"; ".
          "</script>\n";
    } else {
      print "<script>var formAsyncSaveEnabled = false;</script>\n";
    }

  print "</head>\n<body class='admin_form'>";
}


function EndHtml ()
{
    if ($_POST["NC_HTTP_REQUEST"]) // saved via XMLHttpRequest
    {
       ob_end_clean(); // [  ]
       if ($GLOBALS["_RESPONSE"]) { print nc_array_json($GLOBALS["_RESPONSE"]); }
       exit;
    }


    if ($GLOBALS["AJAX_SAVER"])
    {
       print "<div class='save_hint'>".NETCAT_HTTP_REQUEST_HINT."</div>";
    }

    global $UI_CONFIG;
    if (is_object($UI_CONFIG) && method_exists($UI_CONFIG, 'to_json')) { print $UI_CONFIG->to_json(); }
 ?>
</body>
</html>
    <?php
}


#     , $dir_name -  , , /netcat/tmp/
function checkPermissions($dir_name,$DOCUMENT_ROOT="")
{
	if(substr(php_uname(),0,7)=="Windows")
		$filepath=$DOCUMENT_ROOT.$dir_name."n123.tmp";
	else
		$filepath=dirname(__FILE__)."/../..".$dir_name."n123.tmp";

	$h = @fopen($filepath, "w");
	if ($h === FALSE)
	{
		printf ("<font color=red>".NETCAT_FILEUPLOAD_ERROR."</font><br>",$dir_name);
		$result = FALSE;
	}
	else
	{
		fclose($h);
		@unlink($filepath);
		$result = TRUE;
	}

	return $result;
}

/**
  *  (<option>)    (<select>)
  *
  * @param array  ,    
  *     (   value, description;  -
  *    parent;   parent,     
  *    ; optgroup;   optgroup  ,   )
  * @param mixed  
  * @param ingeger     (   )
  *
  * @return string
  */
function nc_select_options(&$data, $selected_value="", $level=0, $current_parent=0) {

  if (!is_array($data)) {
    trigger_error("nc_select_options: first parameter is not an array", E_USER_WARNING);
    return "";
  }

  $str = "";
  if (!$level) //   
  {
     if (array_key_exists('parent', $data[0])) { //   parent
       foreach ((array)$data as $row) {
         $values[$row['parent']][] = $row;
       }
     }
     else { //           
       $values = array(&$data);
     }
  }
  else { //   
    $values = &$data;
  }

  foreach ((array)$values[$current_parent] as $row) {
     if ($row['optgroup'] && ($optgroup != $row['optgroup'])) {
       $optgroup = $row['optgroup'];
       $str .= "<optgroup label='".$optgroup."'>\n";
     }
     $str .= "<option value=\"".htmlspecialchars($row['value'])."\"".
             ($row['value']==$selected_value ? ' selected' : '').
             ">".
             str_repeat("&nbsp; &nbsp; &nbsp;", $level) .
             htmlspecialchars($row['description'])."</option>\n";

     if ($values[$row['value']]) {
       $str .= nc_select_options($values, $selected_value, $level+1, $row['value']);
     }
  }

  return $str;
}


/**
  *     
  *
  * @param string $value  
  * @param array $array ,     $value
  * @return bool
  */
function nc_deep_in_array($value, $array) {
    foreach($array as $item) {
        if(!is_array($item)) {
            if ($item == $value) return true;
            else continue;
        }

        if(in_array($value, $item)) return true;
        else if(nc_deep_in_array($value, $item)) return true;
    }
    return false;
}
?>